# Record Class LCategory

java.lang.Object
java.lang.Record
com.io7m.laurel.model.LCategory

Record Components:
  `id` - The ID
  `name` - The caption
  `required` - The category is required

All Implemented Interfaces:
  `Comparable<LCategory>`

public record LCategory(LCategoryID id, LCategoryName name, boolean required) extends Record implements Comparable<LCategory>
A caption along with its ID.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LCategory(LCategoryID id, LCategoryName name, boolean required)`
  A caption along with its ID.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compareTo(LCategory other)`
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `LCategoryID`
  `id()`
  Returns the value of the `id` record component.
  `LCategoryName`
  `name()`
  Returns the value of the `name` record component.
  `boolean`
  `required()`
  Returns the value of the `required` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### LCategory

    public LCategory(LCategoryID id, LCategoryName name, boolean required)
    A caption along with its ID.
    Parameters:
      `id` - The ID
      `name` - The caption
      `required` - The category is required

- ## Method Details

  - ### compareTo

    public int compareTo(LCategory other)
    Specified by:
      `compareTo` in interface `Comparable<LCategory>`

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with the `compare` method from their corresponding wrapper classes.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### id

    public LCategoryID id()
    Returns the value of the `id` record component.
    Returns:
      the value of the `id` record component

  - ### name

    public LCategoryName name()
    Returns the value of the `name` record component.
    Returns:
      the value of the `name` record component

  - ### required

    public boolean required()
    Returns the value of the `required` record component.
    Returns:
      the value of the `required` record component